import pygame
import sys
import random
import time
import math

pygame.init()

width, height = 800, 600
screen = pygame.display.set_mode((width, height))
pygame.display.set_caption("Cookie Stealer")

clock = pygame.time.Clock()
pygame.mixer.music.load("kitback.mp3")  # Replace with the actual path
pygame.mixer.music.set_volume(0.3)
pygame.mixer.music.play(-1)
class Basket:
    def __init__(self, x, y, width, height, speed):
        self.rect = pygame.Rect(x, y, width, height)
        original_basket_image = pygame.image.load("bas.png")  # Replace with the actual path
        self.image = pygame.transform.scale(original_basket_image, (120, int(120/original_basket_image.get_width()*original_basket_image.get_height())))
        self.speed = speed

    def move_left(self):
        self.rect.x -= self.speed
        if self.rect.x < 0:
            self.rect.x = 0

    def move_right(self):
        self.rect.x += self.speed
        if self.rect.x > width - 120:
            self.rect.x = width - 120

    def draw(self, screen):
        screen.blit(self.image, self.rect)

class FallingBall:
    def __init__(self, x, y, radius, speed):
        self.rect = pygame.Rect(x, y, radius * 2, radius * 2)
        original_ball_image = pygame.image.load("cookie.png")  # Replace with the actual path
        self.image = pygame.transform.scale(original_ball_image, (40, 40))
        self.speed = speed

    def update(self):
        self.rect.y += self.speed

    def draw(self, screen):
        screen.blit(self.image, self.rect)

class Game:
    def __init__(self):
        self.animation_frame = 0
        self.animation_framet = 180
        self.animation_frame22 = 0
        self.basket = Basket(width // 2 - 60, height - 82, 80, 20, 10)
        self.falling_balls = []
        self.ball_score = 0
        self.start_time = 0
        self.game_over = True
        self.game_started = False
        self.font = pygame.font.Font(None, 36)
        self.elapsed_time = 0
        self.winning_sound_played = False  # Track if the winning sound has been played

   
        self.capture_sound = pygame.mixer.Sound("bite.wav")  # Replace with the actual path
        self.fall_sound = pygame.mixer.Sound("no.wav")  # Replace with the actual path
        # <Winning sound>
        self.win_sound = pygame.mixer.Sound("complete.wav")  # Replace with the actual path

        capture_sound_volume = 0.7
        fall_sound_volume = 0.3
        win_sound_volume = .9
        self.capture_sound.set_volume(capture_sound_volume)
        self.fall_sound.set_volume(fall_sound_volume)
        self.win_sound.set_volume(win_sound_volume)

        


        # <Background images>
        original_game_background = pygame.image.load("kit.jpg")  # Replace with the actual path
        self.game_background = pygame.transform.scale(original_game_background, (width, height))
        original_title_background = pygame.image.load("backer.png")  # Replace with the actual path
        self.title_background = pygame.transform.scale(original_title_background, (width, height))

    def reset_game(self):
        self.__init__()

    def start_game(self):
        self.reset_game()
        self.game_over = False
        self.game_started = True
        self.start_time = time.time()
        self.winning_sound_played = False  # Reset the flag when starting a new game

    def update(self):
        

        if not self.game_over:
            # Generate falling balls
            if random.randint(0, 100) < 3:#speed of spawning
                x_position = random.randint(0, width - 20)
                self.falling_balls.append(FallingBall(x_position, 0, 10, 4))

            # Update and draw falling balls
            for ball in self.falling_balls[:]:
                ball.update()
                ball.draw(screen)

                # Check for collisions with the basket
                if self.basket.rect.colliderect(ball.rect):
                    self.falling_balls.remove(ball)
                    self.ball_score += 1
                    self.capture_sound.play()

                # Check if ball dropped below the screen
                if ball.rect.y > height:
                    self.fall_sound.play()
                    self.falling_balls.remove(ball)
                    self.fall_sound.play()
                    if self.ball_score > 0:
                        self.ball_score -= 1
                        self.fall_sound.play()

            # Draw the basket
            self.basket.draw(screen)

            timescore = pygame.font.Font(None,32)
            time_score_text = timescore.render("Catch 20 Cookies", True, 0)
            screen.blit(time_score_text, (312, 11))
            timescore = pygame.font.Font(None,32)
            time_score_text = timescore.render("Catch 20 Cookies", True, (185,242,255))
            screen.blit(time_score_text, (310, 10))
            # Display scores
            ball_score_text = self.font.render(f"Cookies Stolen: {self.ball_score}", True, 0)
            screen.blit(ball_score_text, (10, 10))
            ball_score_text2 = self.font.render(f"Cookies Stolen: {self.ball_score}", True, (255,255,255))
            screen.blit(ball_score_text2, (8, 8))

            self.elapsed_time = time.time() - self.start_time

            time_score_text = self.font.render(f"Time: {self.elapsed_time:.2f}s", True, 0)
            screen.blit(time_score_text, (width - 150, 10))
            time_score_text2 = self.font.render(f"Time: {self.elapsed_time:.2f}s", True, (255,255,255))
            screen.blit(time_score_text2, (width - 152, 8))



            # Check for game over condition
            if self.ball_score >= 20:
                self.game_over = True
                self.show_game_over_screen()

        else:
            self.show_game_over_screen()

    def show_game_over_screen(self):
        self.animation_frame += 2
        if self.animation_frame > 360:  # Reset frame after a full sine wave cycle
                self.animation_frame = 0
        animation_offset = 10 * math.sin(math.radians(self.animation_frame))  # Adjust the amplitude as needed     


        self.animation_framet += 2
        if self.animation_framet > 360:  # Reset frame after a full sine wave cycle
                self.animation_framet = 0
        animation_offsett = 5 * math.sin(math.radians(self.animation_framet))  # Adjust the amplitude as needed    
        screen.blit(self.title_background, (0, 0))

        title_font = pygame.font.Font(None, 72)  # Change 72 to your desired font size
        titleword = title_font.render("Cookie Stealer", True, (0, 0, 0))  # Use title_font here
        screen.blit(titleword, (width // 2 - 168, 20-animation_offsett))
        title_font2 = pygame.font.Font(None, 72)  # Change 72 to your desired font size
        titleword2 = title_font2.render("Cookie Stealer", True, (255,255,255))  # Use title_font here
        screen.blit(titleword2, (width // 2 - 170,20-animation_offsett))

        cookiescore = pygame.font.Font(None, 32)  # Change 72 to your desired font size
        cookiescore2 = cookiescore.render(f"Cookies Stolen: {self.ball_score}", True, 0)  # Use title_font here
        screen.blit(cookiescore2, (width // 2 - 80, height//2-170 ))
        cookiescore2 = pygame.font.Font(None, 32)  # Change 72 to your desired font size
        cookiescore22 = cookiescore2.render(f"Cookies Stolen: {self.ball_score}", True, (0,183,235))  # Use title_font here
        screen.blit(cookiescore22, (width // 2 - 82, height//2-172 ))


        timescore = pygame.font.Font(None,62)
        time_score_text = timescore.render("Start", True, 0)
        screen.blit(time_score_text, (width // 2 - 48,height // 2 + 20 - animation_offset))
        timescore = pygame.font.Font(None,62)
        time_score_text = timescore.render("Start", True, (166,231,255))
        screen.blit(time_score_text, (width // 2 - 50, height // 2 + 20 - animation_offset))

        timscore = pygame.font.Font(None,32)
        time_score_text = timscore.render(f"Time: {self.elapsed_time:.2f}s", True, 0)
        screen.blit(time_score_text, (width // 2 - 55, height // 2 - 130))
        
        timscore = pygame.font.Font(None,32)
        time_score_text = timscore.render(f"Time: {self.elapsed_time:.2f}s", True, (0,183,235))
        screen.blit(time_score_text, (width // 2 - 57, height // 2  -132))
        self.animation_frame22 += 2
        if self.animation_frame22 > 360:  # Reset frame after a full sine wave cycle
                self.animation_frame22 = 0
        animation_offsettt = 5 * math.sin(math.radians(self.animation_frame22))  # Adjust the amplitude as needed    
        
        original_ball_image3 = pygame.image.load("cookie.png")  # Replace with the actual path
        image = pygame.transform.scale(original_ball_image3, (40,40))
        screen.blit(image, (380, 250 - animation_offsettt))

        # <Play winning sound>
        if not self.winning_sound_played:
            self.win_sound.play()
            self.winning_sound_played = True  # Set the flag to true to avoid repeated playing

        pygame.display.flip()

    def title_screen(self):
        screen.blit(self.title_background, (0, 0))
        self.animation_frame += 2
        if self.animation_frame > 360:  # Reset frame after a full sine wave cycle
                self.animation_frame = 0
        animation_offset = 10 * math.sin(math.radians(self.animation_frame))  # Adjust the amplitude as needed    

        self.animation_framet += 2
        if self.animation_framet > 360:  # Reset frame after a full sine wave cycle
                self.animation_framet = 0
        animation_offsett = 5 * math.sin(math.radians(self.animation_framet))  # Adjust the amplitude as needed    
        screen.blit(self.title_background, (0, 0))

        title_font = pygame.font.Font(None, 72)  # Change 72 to your desired font size
        titleword = title_font.render("Cookie Stealer", True, (0, 0, 0))  # Use title_font here
        screen.blit(titleword, (width // 2 - 168, 20-animation_offsett))
        title_font2 = pygame.font.Font(None, 72)  # Change 72 to your desired font size
        titleword2 = title_font2.render("Cookie Stealer", True, (255,255,255))  # Use title_font here
        screen.blit(titleword2, (width // 2 - 170,20-animation_offsett))

        self.animation_frame22 += 2
        if self.animation_frame22 > 360:  # Reset frame after a full sine wave cycle
                self.animation_frame22 = 0
        animation_offsettt = 5 * math.sin(math.radians(self.animation_frame22))  # Adjust the amplitude as needed    
        
        original_ball_image3 = pygame.image.load("cookie.png")  # Replace with the actual path
        image = pygame.transform.scale(original_ball_image3, (40,40))
        screen.blit(image, (380, 250 - animation_offsettt))
        # cookiescore = pygame.font.Font(None, 32)  # Change 72 to your desired font size
        # cookiescore2 = cookiescore.render(f"Cookies Stolen: {self.ball_score}", True, 0)  # Use title_font here
        # screen.blit(cookiescore2, (width // 2 - 70, height//2-150 ))
        # cookiescore2 = pygame.font.Font(None, 32)  # Change 72 to your desired font size
        # cookiescore22 = cookiescore2.render(f"Cookies Stolen: {self.ball_score}", True, (176,224,230))  # Use title_font here
        # screen.blit(cookiescore22, (width // 2 - 72, height//2-152 ))



        timescore = pygame.font.Font(None,62)
        time_score_text = timescore.render("Start", True, 0)
        screen.blit(time_score_text, (width // 2 - 48, height // 2 + 20 - animation_offset))
        timescore = pygame.font.Font(None,62)
        time_score_text = timescore.render("Start", True, (166,231,255))
        screen.blit(time_score_text, (width // 2 - 50, height // 2 + 20 - animation_offset))


        pygame.display.flip()

    def draw_game_background(self):
        screen.blit(self.game_background, (0, 0))

game = Game()

while True:
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            pygame.quit()
            sys.exit()

        if event.type == pygame.MOUSEBUTTONDOWN:
            if game.game_over:
                game.start_game()
            else:
                game.reset_game()

    keys = pygame.key.get_pressed()
    if keys[pygame.K_LEFT]:
        game.basket.move_left()
    if keys[pygame.K_RIGHT]:
        game.basket.move_right()

    screen.fill((0, 0, 0))

    if game.game_started:
        game.draw_game_background()
        game.update()
    else:
        game.title_screen()

    pygame.display.flip()
    clock.tick(60)
